	//script reusable
	if not escapetime
	rawset(_G, "escapetime", -1)
	end
	if not pausedescapetime
	rawset(_G, "pausedescapetime", -1)
	end
	
	rawset(_G, "StartEscape", function()
		if (escapetime == -1)
		escapetime = tonumber(mapheaderinfo[gamemap].escapetimelimit) * TICRATE
		end
	end)
	
	rawset(_G, "ResumeEscape", function()
	escapetime = pausedescapetime
	pausedescapetime = -1
	end)
	
	rawset(_G, "StopEscape", function()
		if (escapetime ~= -1)
		pausedescapetime = escapetime
		escapetime = -1
		end
	end)
	
	addHook("PlayerThink", function(player)
		if (mapheaderinfo[gamemap].escapepunish == nil and mapheaderinfo[gamemap].escapetimelimit == nil)
		return end
		if (mapheaderinfo[gamemap].escapestartsector ~= nil and player.mo.subsector.sector == sectors[mapheaderinfo[gamemap].escapestartsector])
		and P_IsObjectOnGround(player.mo)
		and not (escapetime >= 0)
		StartEscape()
		end
		if (tonumber(mapheaderinfo[gamemap].escapepunish) == 1)
		and (escapetime == 0)
		P_DamageMobj(player.mo, nil, nil, nil, DMG_INSTAKILL)
		end
		if (tonumber(mapheaderinfo[gamemap].escapepunish) == 2)
		and (escapetime == 0)
		escapetime = $ + 1
		player.score = $ - 1
		end
		if (tonumber(mapheaderinfo[gamemap].escapepunish) == 3)
		and (escapetime == 0)
		escapetime = $ + 1
		end
		if (tonumber(mapheaderinfo[gamemap].escapepunish) == 3)
		and (escapetime == 0 or escapetime == 1)
		and (leveltime % TICRATE * 10)
		P_GivePlayerRings(player, -1)
		end
	end)
	
	addHook("ThinkFrame", function ()
		if (escapetime ~= -1)
		escapetime = $ - 1
		end
	end)
	
	addHook("MapLoad", function()
	escapetime = -1
	end)

	local function HURRYUP(v, player)
		if escapetime >= 0
		v.drawString(140, 20, "\x82"+G_TicsToMinutes(escapetime)+" : "+G_TicsToSeconds(escapetime)+"", V_YELLOWMAP|V_SNAPTOTOP)
		end
	end
	hud.add(HURRYUP, "game")